import { EntitySchema, ExtractSchemaOutputType } from "./schemas/Entity";
export declare type NormalizationResultType = string | string[] | NormalizationResultObject;
interface NormalizationResultObject extends Record<string, NormalizationResultType> {
}
export declare type NormalizationOutput<ResultType, Entities> = {
    result: ResultType;
    entities: Entities;
};
export declare type ValidKey = string | number | symbol;
export declare type ValueOf<T> = T[keyof T];
export interface Schema<Input extends Record<ValidKey, any>, Name extends string, ResultType extends NormalizationResultType, EntitiesOutput extends Record<string, Record<string, any>>> {
    nameProp: Name;
    normalizeWith(input: Input, parent: any, objectKey: string | undefined): NormalizationOutput<ResultType, EntitiesOutput>;
}
export declare type ExtractSchemaResultType<T extends AnySchema> = T extends Schema<any, any, infer R, any> ? R : never;
export declare class PropBuilder<SchemaName extends string, ResultType extends NormalizationResultType> {
    schemaName: SchemaName;
    constructor(input: SchemaName);
    build<InputType extends Record<ValidKey, any>, EntitiesOutput extends Record<string, Record<string, any>>, S extends EntitySchema<InputType, any, SchemaName, any, EntitiesOutput>>(schemas: Record<SchemaName, S>): Schema<InputType, SchemaName, ResultType, EntitiesOutput>;
}
export declare type ExtractPropBuilderResultType<T extends PropBuilder<any, any>> = T extends PropBuilder<any, infer R> ? R : never;
export interface SchemaPropBuilder<SchemaName extends string, ResultType extends NormalizationResultType, SchemaType extends EntitySchema<any, any, SchemaName, any, any>> extends PropBuilder<SchemaName, ResultType> {
    schema: SchemaType;
    basePropBuilder(): PropBuilder<SchemaName, ResultType>;
}
export declare type ExtractSchemaPropResultType<T extends SchemaPropBuilder<any, any, any>> = T extends SchemaPropBuilder<any, infer R, any> ? R : never;
export declare type ExtractSchemaPropOutputType<T extends SchemaPropBuilder<any, any, any>> = T extends SchemaPropBuilder<any, any, infer S> ? ExtractSchemaOutputType<S> : never;
export declare type ValidSchemaProp<T extends string> = T | PropBuilder<T, any> | SchemaPropBuilder<T, any, any>;
export declare type ExtractSchemaNames<T extends AnySchema> = T extends Schema<any, infer N, any, any> ? N : never;
export declare type AnySchema = Schema<any, any, any, any>;
export {};
